import{s as Ve,o as Le,n as we}from"../chunks/scheduler.9bc65507.js";import{S as He,i as Re,g as d,s as p,r as y,A as Ee,h,f as t,c,j as Je,u as j,x,k as Ue,y as Ne,a as n,v as w,d as M,t as k,w as v}from"../chunks/index.707bf1b6.js";import{T as Ae}from"../chunks/Tip.c2ecdbf4.js";import{C as A}from"../chunks/CodeBlock.54a9f38d.js";import{F as ze,M as Ge}from"../chunks/Markdown.8ab98a13.js";import{H as O}from"../chunks/Heading.342b1fa6.js";function Xe(W){let a,u='Remember, architecture refers to the skeleton of the model and checkpoints are the weights for a given architecture. For example, <a href="https://huggingface.co/bert-base-uncased" rel="nofollow">BERT</a> is an architecture, while <code>bert-base-uncased</code> is a checkpoint. Model is a general term that can mean either architecture or checkpoint.';return{c(){a=d("p"),a.innerHTML=u},l(l){a=h(l,"P",{"data-svelte-h":!0}),x(a)!=="svelte-a5apxu"&&(a.innerHTML=u)},m(l,o){n(l,a,o)},p:we,d(l){l&&t(a)}}}function Pe(W){let a,u='For PyTorch models, the <code>from_pretrained()</code> method uses <code>torch.load()</code> which internally uses <code>pickle</code> and is known to be insecure. In general, never load a model that could have come from an untrusted source, or that could have been tampered with. This security risk is partially mitigated for public models hosted on the Hugging Face Hub, which are <a href="https://huggingface.co/docs/hub/security-malware" rel="nofollow">scanned for malware</a> at each commit. See the <a href="https://huggingface.co/docs/hub/security" rel="nofollow">Hub documentation</a> for best practices like <a href="https://huggingface.co/docs/hub/security-gpg#signing-commits-with-gpg" rel="nofollow">signed commit verification</a> with GPG.',l,o,f="TensorFlow and Flax checkpoints are not affected, and can be loaded within PyTorch architectures using the <code>from_tf</code> and <code>from_flax</code> kwargs for the <code>from_pretrained</code> method to circumvent this issue.";return{c(){a=d("p"),a.innerHTML=u,l=p(),o=d("p"),o.innerHTML=f},l(m){a=h(m,"P",{"data-svelte-h":!0}),x(a)!=="svelte-12xgjc6"&&(a.innerHTML=u),l=c(m),o=h(m,"P",{"data-svelte-h":!0}),x(o)!=="svelte-gbqaor"&&(o.innerHTML=f)},m(m,Z){n(m,a,Z),n(m,l,Z),n(m,o,Z)},p:we,d(m){m&&(t(a),t(l),t(o))}}}function Ye(W){let a,u='Finally, the <code>AutoModelFor</code> classes let you load a pretrained model for a given task (see <a href="model_doc/auto">here</a> for a complete list of available tasks). For example, load a model for sequence classification with <a href="/docs/transformers/main/en/model_doc/auto#transformers.FlaxAutoModelForVision2Seq.from_pretrained">AutoModelForSequenceClassification.from_pretrained()</a>:',l,o,f,m,Z="Easily reuse the same checkpoint to load an architecture for a different task:",J,g,T,b,C,F,i='Generally, we recommend using the <code>AutoTokenizer</code> class and the <code>AutoModelFor</code> class to load pretrained instances of models. This will ensure you load the correct architecture every time. In the next <a href="preprocessing">tutorial</a>, learn how to use your newly loaded tokenizer, image processor, feature extractor and processor to preprocess a dataset for fine-tuning.',$;return o=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Nb2RlbEZvclNlcXVlbmNlQ2xhc3NpZmljYXRpb24lMEElMEFtb2RlbCUyMCUzRCUyMEF1dG9Nb2RlbEZvclNlcXVlbmNlQ2xhc3NpZmljYXRpb24uZnJvbV9wcmV0cmFpbmVkKCUyMmRpc3RpbGJlcnQtYmFzZS11bmNhc2VkJTIyKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased&quot;</span>)`,wrap:!1}}),g=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Nb2RlbEZvclRva2VuQ2xhc3NpZmljYXRpb24lMEElMEFtb2RlbCUyMCUzRCUyMEF1dG9Nb2RlbEZvclRva2VuQ2xhc3NpZmljYXRpb24uZnJvbV9wcmV0cmFpbmVkKCUyMmRpc3RpbGJlcnQtYmFzZS11bmNhc2VkJTIyKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForTokenClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForTokenClassification.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased&quot;</span>)`,wrap:!1}}),b=new Ae({props:{warning:!0,$$slots:{default:[Pe]},$$scope:{ctx:W}}}),{c(){a=d("p"),a.innerHTML=u,l=p(),y(o.$$.fragment),f=p(),m=d("p"),m.textContent=Z,J=p(),y(g.$$.fragment),T=p(),y(b.$$.fragment),C=p(),F=d("p"),F.innerHTML=i},l(r){a=h(r,"P",{"data-svelte-h":!0}),x(a)!=="svelte-nj6m0x"&&(a.innerHTML=u),l=c(r),j(o.$$.fragment,r),f=c(r),m=h(r,"P",{"data-svelte-h":!0}),x(m)!=="svelte-98u76l"&&(m.textContent=Z),J=c(r),j(g.$$.fragment,r),T=c(r),j(b.$$.fragment,r),C=c(r),F=h(r,"P",{"data-svelte-h":!0}),x(F)!=="svelte-a18ug5"&&(F.innerHTML=i)},m(r,_){n(r,a,_),n(r,l,_),w(o,r,_),n(r,f,_),n(r,m,_),n(r,J,_),w(g,r,_),n(r,T,_),w(b,r,_),n(r,C,_),n(r,F,_),$=!0},p(r,_){const U={};_&2&&(U.$$scope={dirty:_,ctx:r}),b.$set(U)},i(r){$||(M(o.$$.fragment,r),M(g.$$.fragment,r),M(b.$$.fragment,r),$=!0)},o(r){k(o.$$.fragment,r),k(g.$$.fragment,r),k(b.$$.fragment,r),$=!1},d(r){r&&(t(a),t(l),t(f),t(m),t(J),t(T),t(C),t(F)),v(o,r),v(g,r),v(b,r)}}}function qe(W){let a,u;return a=new Ge({props:{$$slots:{default:[Ye]},$$scope:{ctx:W}}}),{c(){y(a.$$.fragment)},l(l){j(a.$$.fragment,l)},m(l,o){w(a,l,o),u=!0},p(l,o){const f={};o&2&&(f.$$scope={dirty:o,ctx:l}),a.$set(f)},i(l){u||(M(a.$$.fragment,l),u=!0)},o(l){k(a.$$.fragment,l),u=!1},d(l){v(a,l)}}}function Ie(W){let a,u='Finally, the <code>TFAutoModelFor</code> classes let you load a pretrained model for a given task (see <a href="model_doc/auto">here</a> for a complete list of available tasks). For example, load a model for sequence classification with <a href="/docs/transformers/main/en/model_doc/auto#transformers.FlaxAutoModelForVision2Seq.from_pretrained">TFAutoModelForSequenceClassification.from_pretrained()</a>:',l,o,f,m,Z="Easily reuse the same checkpoint to load an architecture for a different task:",J,g,T,b,C='Generally, we recommend using the <code>AutoTokenizer</code> class and the <code>TFAutoModelFor</code> class to load pretrained instances of models. This will ensure you load the correct architecture every time. In the next <a href="preprocessing">tutorial</a>, learn how to use your newly loaded tokenizer, image processor, feature extractor and processor to preprocess a dataset for fine-tuning.',F;return o=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMFRGQXV0b01vZGVsRm9yU2VxdWVuY2VDbGFzc2lmaWNhdGlvbiUwQSUwQW1vZGVsJTIwJTNEJTIwVEZBdXRvTW9kZWxGb3JTZXF1ZW5jZUNsYXNzaWZpY2F0aW9uLmZyb21fcHJldHJhaW5lZCglMjJkaXN0aWxiZXJ0LWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForSequenceClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForSequenceClassification.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased&quot;</span>)`,wrap:!1}}),g=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMFRGQXV0b01vZGVsRm9yVG9rZW5DbGFzc2lmaWNhdGlvbiUwQSUwQW1vZGVsJTIwJTNEJTIwVEZBdXRvTW9kZWxGb3JUb2tlbkNsYXNzaWZpY2F0aW9uLmZyb21fcHJldHJhaW5lZCglMjJkaXN0aWxiZXJ0LWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForTokenClassification

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForTokenClassification.from_pretrained(<span class="hljs-string">&quot;distilbert-base-uncased&quot;</span>)`,wrap:!1}}),{c(){a=d("p"),a.innerHTML=u,l=p(),y(o.$$.fragment),f=p(),m=d("p"),m.textContent=Z,J=p(),y(g.$$.fragment),T=p(),b=d("p"),b.innerHTML=C},l(i){a=h(i,"P",{"data-svelte-h":!0}),x(a)!=="svelte-1nrzgox"&&(a.innerHTML=u),l=c(i),j(o.$$.fragment,i),f=c(i),m=h(i,"P",{"data-svelte-h":!0}),x(m)!=="svelte-98u76l"&&(m.textContent=Z),J=c(i),j(g.$$.fragment,i),T=c(i),b=h(i,"P",{"data-svelte-h":!0}),x(b)!=="svelte-19d9o2j"&&(b.innerHTML=C)},m(i,$){n(i,a,$),n(i,l,$),w(o,i,$),n(i,f,$),n(i,m,$),n(i,J,$),w(g,i,$),n(i,T,$),n(i,b,$),F=!0},p:we,i(i){F||(M(o.$$.fragment,i),M(g.$$.fragment,i),F=!0)},o(i){k(o.$$.fragment,i),k(g.$$.fragment,i),F=!1},d(i){i&&(t(a),t(l),t(f),t(m),t(J),t(T),t(b)),v(o,i),v(g,i)}}}function Qe(W){let a,u;return a=new Ge({props:{$$slots:{default:[Ie]},$$scope:{ctx:W}}}),{c(){y(a.$$.fragment)},l(l){j(a.$$.fragment,l)},m(l,o){w(a,l,o),u=!0},p(l,o){const f={};o&2&&(f.$$scope={dirty:o,ctx:l}),a.$set(f)},i(l){u||(M(a.$$.fragment,l),u=!0)},o(l){k(a.$$.fragment,l),u=!1},d(l){v(a,l)}}}function Se(W){let a,u,l,o,f,m,Z,J="With so many different Transformer architectures, it can be challenging to create one for your checkpoint. As a part of 🤗 Transformers core philosophy to make the library easy, simple and flexible to use, an <code>AutoClass</code> automatically infers and loads the correct architecture from a given checkpoint. The <code>from_pretrained()</code> method lets you quickly load a pretrained model for any architecture so you don’t have to devote time and resources to train a model from scratch. Producing this type of checkpoint-agnostic code means if your code works for one checkpoint, it will work with another checkpoint - as long as it was trained for a similar task - even if the architecture is different.",g,T,b,C,F="In this tutorial, learn to:",i,$,r="<li>Load a pretrained tokenizer.</li> <li>Load a pretrained image processor</li> <li>Load a pretrained feature extractor.</li> <li>Load a pretrained processor.</li> <li>Load a pretrained model.</li>",_,U,te,V,Me="Nearly every NLP task begins with a tokenizer. A tokenizer converts your input into a format that can be processed by the model.",se,L,ke='Load a tokenizer with <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoTokenizer.from_pretrained">AutoTokenizer.from_pretrained()</a>:',ae,H,ne,R,ve="Then tokenize your input as shown below:",le,E,re,N,oe,z,xe="For vision tasks, an image processor processes the image into the correct input format.",ie,X,pe,P,ce,Y,_e="For audio tasks, a feature extractor processes the audio signal the correct input format.",me,q,Te='Load a feature extractor with <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoFeatureExtractor.from_pretrained">AutoFeatureExtractor.from_pretrained()</a>:',ue,I,fe,Q,de,S,Ze='Multimodal tasks require a processor that combines two types of preprocessing tools. For example, the <a href="model_doc/layoutlmv2">LayoutLMV2</a> model requires an image processor to handle images and a tokenizer to handle text; a processor combines both of them.',he,B,Ce='Load a processor with <a href="/docs/transformers/main/en/model_doc/auto#transformers.AutoProcessor.from_pretrained">AutoProcessor.from_pretrained()</a>:',$e,K,be,D,ge,G,ye,ee,je;return f=new O({props:{title:"Load pretrained instances with an AutoClass",local:"load-pretrained-instances-with-an-autoclass",headingTag:"h1"}}),T=new Ae({props:{$$slots:{default:[Xe]},$$scope:{ctx:W}}}),U=new O({props:{title:"AutoTokenizer",local:"autotokenizer",headingTag:"h2"}}),H=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Ub2tlbml6ZXIlMEElMEF0b2tlbml6ZXIlMjAlM0QlMjBBdXRvVG9rZW5pemVyLmZyb21fcHJldHJhaW5lZCglMjJiZXJ0LWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;bert-base-uncased&quot;</span>)`,wrap:!1}}),E=new A({props:{code:"c2VxdWVuY2UlMjAlM0QlMjAlMjJJbiUyMGElMjBob2xlJTIwaW4lMjB0aGUlMjBncm91bmQlMjB0aGVyZSUyMGxpdmVkJTIwYSUyMGhvYmJpdC4lMjIlMEFwcmludCh0b2tlbml6ZXIoc2VxdWVuY2UpKQ==",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>sequence = <span class="hljs-string">&quot;In a hole in the ground there lived a hobbit.&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(tokenizer(sequence))
{<span class="hljs-string">&#x27;input_ids&#x27;</span>: [<span class="hljs-number">101</span>, <span class="hljs-number">1999</span>, <span class="hljs-number">1037</span>, <span class="hljs-number">4920</span>, <span class="hljs-number">1999</span>, <span class="hljs-number">1996</span>, <span class="hljs-number">2598</span>, <span class="hljs-number">2045</span>, <span class="hljs-number">2973</span>, <span class="hljs-number">1037</span>, <span class="hljs-number">7570</span>, <span class="hljs-number">10322</span>, <span class="hljs-number">4183</span>, <span class="hljs-number">1012</span>, <span class="hljs-number">102</span>], 
 <span class="hljs-string">&#x27;token_type_ids&#x27;</span>: [<span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>, <span class="hljs-number">0</span>], 
 <span class="hljs-string">&#x27;attention_mask&#x27;</span>: [<span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>, <span class="hljs-number">1</span>]}`,wrap:!1}}),N=new O({props:{title:"AutoImageProcessor",local:"autoimageprocessor",headingTag:"h2"}}),X=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9JbWFnZVByb2Nlc3NvciUwQSUwQWltYWdlX3Byb2Nlc3NvciUyMCUzRCUyMEF1dG9JbWFnZVByb2Nlc3Nvci5mcm9tX3ByZXRyYWluZWQoJTIyZ29vZ2xlJTJGdml0LWJhc2UtcGF0Y2gxNi0yMjQlMjIp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;google/vit-base-patch16-224&quot;</span>)`,wrap:!1}}),P=new O({props:{title:"AutoFeatureExtractor",local:"autofeatureextractor",headingTag:"h2"}}),I=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9GZWF0dXJlRXh0cmFjdG9yJTBBJTBBZmVhdHVyZV9leHRyYWN0b3IlMjAlM0QlMjBBdXRvRmVhdHVyZUV4dHJhY3Rvci5mcm9tX3ByZXRyYWluZWQoJTBBJTIwJTIwJTIwJTIwJTIyZWhjYWxhYnJlcyUyRndhdjJ2ZWMyLWxnLXhsc3ItZW4tc3BlZWNoLWVtb3Rpb24tcmVjb2duaXRpb24lMjIlMEEp",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoFeatureExtractor

<span class="hljs-meta">&gt;&gt;&gt; </span>feature_extractor = AutoFeatureExtractor.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;ehcalabres/wav2vec2-lg-xlsr-en-speech-emotion-recognition&quot;</span>
<span class="hljs-meta">... </span>)`,wrap:!1}}),Q=new O({props:{title:"AutoProcessor",local:"autoprocessor",headingTag:"h2"}}),K=new A({props:{code:"ZnJvbSUyMHRyYW5zZm9ybWVycyUyMGltcG9ydCUyMEF1dG9Qcm9jZXNzb3IlMEElMEFwcm9jZXNzb3IlMjAlM0QlMjBBdXRvUHJvY2Vzc29yLmZyb21fcHJldHJhaW5lZCglMjJtaWNyb3NvZnQlMkZsYXlvdXRsbXYyLWJhc2UtdW5jYXNlZCUyMik=",highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;microsoft/layoutlmv2-base-uncased&quot;</span>)`,wrap:!1}}),D=new O({props:{title:"AutoModel",local:"automodel",headingTag:"h2"}}),G=new ze({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[Qe],pytorch:[qe]},$$scope:{ctx:W}}}),{c(){a=d("meta"),u=p(),l=d("p"),o=p(),y(f.$$.fragment),m=p(),Z=d("p"),Z.innerHTML=J,g=p(),y(T.$$.fragment),b=p(),C=d("p"),C.textContent=F,i=p(),$=d("ul"),$.innerHTML=r,_=p(),y(U.$$.fragment),te=p(),V=d("p"),V.textContent=Me,se=p(),L=d("p"),L.innerHTML=ke,ae=p(),y(H.$$.fragment),ne=p(),R=d("p"),R.textContent=ve,le=p(),y(E.$$.fragment),re=p(),y(N.$$.fragment),oe=p(),z=d("p"),z.textContent=xe,ie=p(),y(X.$$.fragment),pe=p(),y(P.$$.fragment),ce=p(),Y=d("p"),Y.textContent=_e,me=p(),q=d("p"),q.innerHTML=Te,ue=p(),y(I.$$.fragment),fe=p(),y(Q.$$.fragment),de=p(),S=d("p"),S.innerHTML=Ze,he=p(),B=d("p"),B.innerHTML=Ce,$e=p(),y(K.$$.fragment),be=p(),y(D.$$.fragment),ge=p(),y(G.$$.fragment),ye=p(),ee=d("p"),this.h()},l(e){const s=Ee("svelte-u9bgzb",document.head);a=h(s,"META",{name:!0,content:!0}),s.forEach(t),u=c(e),l=h(e,"P",{}),Je(l).forEach(t),o=c(e),j(f.$$.fragment,e),m=c(e),Z=h(e,"P",{"data-svelte-h":!0}),x(Z)!=="svelte-j0p9ct"&&(Z.innerHTML=J),g=c(e),j(T.$$.fragment,e),b=c(e),C=h(e,"P",{"data-svelte-h":!0}),x(C)!=="svelte-1kmbcqk"&&(C.textContent=F),i=c(e),$=h(e,"UL",{"data-svelte-h":!0}),x($)!=="svelte-12313ht"&&($.innerHTML=r),_=c(e),j(U.$$.fragment,e),te=c(e),V=h(e,"P",{"data-svelte-h":!0}),x(V)!=="svelte-8r2c79"&&(V.textContent=Me),se=c(e),L=h(e,"P",{"data-svelte-h":!0}),x(L)!=="svelte-1kt9dw1"&&(L.innerHTML=ke),ae=c(e),j(H.$$.fragment,e),ne=c(e),R=h(e,"P",{"data-svelte-h":!0}),x(R)!=="svelte-1idptsb"&&(R.textContent=ve),le=c(e),j(E.$$.fragment,e),re=c(e),j(N.$$.fragment,e),oe=c(e),z=h(e,"P",{"data-svelte-h":!0}),x(z)!=="svelte-1d6dyuq"&&(z.textContent=xe),ie=c(e),j(X.$$.fragment,e),pe=c(e),j(P.$$.fragment,e),ce=c(e),Y=h(e,"P",{"data-svelte-h":!0}),x(Y)!=="svelte-f3nvdu"&&(Y.textContent=_e),me=c(e),q=h(e,"P",{"data-svelte-h":!0}),x(q)!=="svelte-w6dlio"&&(q.innerHTML=Te),ue=c(e),j(I.$$.fragment,e),fe=c(e),j(Q.$$.fragment,e),de=c(e),S=h(e,"P",{"data-svelte-h":!0}),x(S)!=="svelte-p2h4f9"&&(S.innerHTML=Ze),he=c(e),B=h(e,"P",{"data-svelte-h":!0}),x(B)!=="svelte-wn0ar2"&&(B.innerHTML=Ce),$e=c(e),j(K.$$.fragment,e),be=c(e),j(D.$$.fragment,e),ge=c(e),j(G.$$.fragment,e),ye=c(e),ee=h(e,"P",{}),Je(ee).forEach(t),this.h()},h(){Ue(a,"name","hf:doc:metadata"),Ue(a,"content",Be)},m(e,s){Ne(document.head,a),n(e,u,s),n(e,l,s),n(e,o,s),w(f,e,s),n(e,m,s),n(e,Z,s),n(e,g,s),w(T,e,s),n(e,b,s),n(e,C,s),n(e,i,s),n(e,$,s),n(e,_,s),w(U,e,s),n(e,te,s),n(e,V,s),n(e,se,s),n(e,L,s),n(e,ae,s),w(H,e,s),n(e,ne,s),n(e,R,s),n(e,le,s),w(E,e,s),n(e,re,s),w(N,e,s),n(e,oe,s),n(e,z,s),n(e,ie,s),w(X,e,s),n(e,pe,s),w(P,e,s),n(e,ce,s),n(e,Y,s),n(e,me,s),n(e,q,s),n(e,ue,s),w(I,e,s),n(e,fe,s),w(Q,e,s),n(e,de,s),n(e,S,s),n(e,he,s),n(e,B,s),n(e,$e,s),w(K,e,s),n(e,be,s),w(D,e,s),n(e,ge,s),w(G,e,s),n(e,ye,s),n(e,ee,s),je=!0},p(e,[s]){const Fe={};s&2&&(Fe.$$scope={dirty:s,ctx:e}),T.$set(Fe);const We={};s&2&&(We.$$scope={dirty:s,ctx:e}),G.$set(We)},i(e){je||(M(f.$$.fragment,e),M(T.$$.fragment,e),M(U.$$.fragment,e),M(H.$$.fragment,e),M(E.$$.fragment,e),M(N.$$.fragment,e),M(X.$$.fragment,e),M(P.$$.fragment,e),M(I.$$.fragment,e),M(Q.$$.fragment,e),M(K.$$.fragment,e),M(D.$$.fragment,e),M(G.$$.fragment,e),je=!0)},o(e){k(f.$$.fragment,e),k(T.$$.fragment,e),k(U.$$.fragment,e),k(H.$$.fragment,e),k(E.$$.fragment,e),k(N.$$.fragment,e),k(X.$$.fragment,e),k(P.$$.fragment,e),k(I.$$.fragment,e),k(Q.$$.fragment,e),k(K.$$.fragment,e),k(D.$$.fragment,e),k(G.$$.fragment,e),je=!1},d(e){e&&(t(u),t(l),t(o),t(m),t(Z),t(g),t(b),t(C),t(i),t($),t(_),t(te),t(V),t(se),t(L),t(ae),t(ne),t(R),t(le),t(re),t(oe),t(z),t(ie),t(pe),t(ce),t(Y),t(me),t(q),t(ue),t(fe),t(de),t(S),t(he),t(B),t($e),t(be),t(ge),t(ye),t(ee)),t(a),v(f,e),v(T,e),v(U,e),v(H,e),v(E,e),v(N,e),v(X,e),v(P,e),v(I,e),v(Q,e),v(K,e),v(D,e),v(G,e)}}}const Be='{"title":"Load pretrained instances with an AutoClass","local":"load-pretrained-instances-with-an-autoclass","sections":[{"title":"AutoTokenizer","local":"autotokenizer","sections":[],"depth":2},{"title":"AutoImageProcessor","local":"autoimageprocessor","sections":[],"depth":2},{"title":"AutoFeatureExtractor","local":"autofeatureextractor","sections":[],"depth":2},{"title":"AutoProcessor","local":"autoprocessor","sections":[],"depth":2},{"title":"AutoModel","local":"automodel","sections":[],"depth":2}],"depth":1}';function Ke(W){return Le(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class nt extends He{constructor(a){super(),Re(this,a,Ke,Se,Ve,{})}}export{nt as component};
